#include <stdio.h>
#include <cutil_inline.h>

__global__ void kernel( int*In, int*Out)
{
	int tid = blockIdx.x * blockDim.x+ threadIdx.x;

	Out[tid] = In[tid]*2;
}

int main()
{
	const int nBlocks = 65535;		// 
	const int nThreads = 512;		// 
	const int N = 512*65535;		// 
	const int Size = N*sizeof(int);	// 

	int* host_In;
	int* host_Out;

	//ȣƮ ޸ Ҵ
	cudaMallocHost((void**)&host_In,Size);
	cudaMallocHost((void**)&host_Out,Size);

	// Է
	for( int i = 0; i < N; i++)
	{
		host_In[i] = i;
		host_Out[i] = 0;
	}

	int* dev_In;
	int* dev_Out;

	//̽ ޸ Ҵ
	cudaMalloc((void**)&dev_In, Size);
	cudaMalloc((void**)&dev_Out, Size);

	cudaMemset(dev_In, 0, Size);
	cudaMemset(dev_Out, 0, Size);

	//ȣƮ ̽ Է  
	cudaMemcpy(dev_In, host_In, Size, cudaMemcpyHostToDevice);

	//2 
	kernel<<<nBlocks,nThreads>>>(dev_In, dev_Out);

	//̽ ȣƮ   
	cudaMemcpy(host_Out, dev_Out, Size, cudaMemcpyDeviceToHost);

	cudaFree(dev_In);
	cudaFree(dev_Out);

	// 
	for( int i = 0; i < 10; i++)
	{
		printf(" host_Out[%d] : %d\n",i,host_Out[i]);
	}
	printf(" ......\n");
	for( int i = N-5; i < N; i++)
	{
		printf(" host_Out[%d] : %d\n",i,host_Out[i]);
	}

	cudaFreeHost(host_In);
	cudaFreeHost(host_Out);

	return 0;
}