#include <cutil_inline.h>

#define MAX_SIZE 2048

__global__ void CoalescingMemory(float* gData)
{
	int LoadStoreSize = MAX_SHAREDSIZE/blockDim.x;

	int begin = LoadStoreSize*threadIdx.x;
	int end = begin+LoadStoreSize;

	//8K ޸ Ҵ
	__shared__ int SharedMemory[MAX_SHAREDSIZE];

	int i = 0;
	for( i = begin; i < end; i++)
		SharedMemory[i] = In[i];
	
	__syncthreads();

	for( i = begin; i < end; i++)
		Out[i] = SharedMemory[i];

	__syncthreads();
}

int main()
{
	const int BufferSize = MAX_SIZE*sizeof(float);

	float* hData;

	//ȣƮ ޸ Ҵ
	hData = (float*)malloc( BufferSize);

	int i = 0;

	// Է
	for( i = 0; i < size; i++)
	{
		hData[i] = i;
	}

	float* gData;

	//̽ ޸ Ҵ
	cudaMalloc((void**)&gData, BufferSize);

	//ȣƮ ̽ Է  
	cudaMemcpy(gData, hData, BufferSize, cudaMemcpyHostToDevice);

	//޸ а 
	LoadStoreSharedMemory<<<32,512>>>(gData);

	cudaFree(gData);

	free(hData);
	
	return 0;
}