#include <cutil.h> // CUDA Utility Tools 

int main()
{
	const int size = 1024*1024*200;
	const int BufferSize = size*sizeof(int);

	// ޸ 
	int* PageableMemoryIn;
	int* PageableMemoryOut;

	PageableMemoryIn = (int*)malloc(BufferSize);
	PageableMemoryOut = (int*)malloc(BufferSize);

	for( int i = 0; i < size; i++)
	{
		PageableMemoryIn[i] = i;
		PageableMemoryOut[i] = 0;
	}

	//̽ ޸ 
	int* DeviceMemory;

	cudaMalloc((void**)&DeviceMemory, BufferSize);

	//Ÿ̸ 
	unsigned int PageableTimer;

	cutCreateTimer(&PageableTimer);
	cutStartTimer(PageableTimer);	//ð  

	cudaMemcpy(DeviceMemory, PageableMemoryIn, BufferSize, cudaMemcpyHostToDevice);

	cudaMemcpy(PageableMemoryOut, DeviceMemory, BufferSize, cudaMemcpyDeviceToHost);

	cutStopTimer(PageableTimer);	//ð  
	double elapsed_time = cutGetTimerValue(PageableTimer);

	printf("  ޸ ۽ð : %f mse\n",elapsed_time);
	free(PageableMemoryIn);
	free(PageableMemoryOut);

	int* PinnedMemoryIn;
	int* PinnedMemoryOut;
	
	cudaMallocHost((void**)&PinnedMemoryIn, BufferSize);
	cudaMallocHost((void**)&PinnedMemoryOut, BufferSize);
	
	for( int i = 0; i < size; i++)
	{
		PinnedMemoryIn[i] = i;
		PinnedMemoryOut[i] = 0;
	}
	unsigned int PinnedTimer;

	cutCreateTimer(&PinnedTimer);
	
	cutStartTimer(PinnedTimer);	//ð  
	cudaMemcpy(DeviceMemory, PinnedMemoryIn, BufferSize, cudaMemcpyHostToDevice);

	cudaMemcpy(PinnedMemoryOut, DeviceMemory, BufferSize, cudaMemcpyDeviceToHost);
	
	cutStopTimer(PinnedTimer);	//ð  
	elapsed_time = cutGetTimerValue(PinnedTimer);

	printf(" ޸ ۽ð : %f mse\n",elapsed_time);

	cudaFreeHost(PinnedMemoryIn);
	cudaFreeHost(PinnedMemoryOut);
	cudaFree(DeviceMemory);

	return 0;
}