#include <cutil_inline.h>
#include <cutil.h> // CUDA Utility Tools
#include <math.h>

__global__ void AtomicShared( int* nThreadCount)
{
	__shared__ int nCount;

	nCount = 0;
	__syncthreads();

	atomicAdd(&nCount,1);
	__syncthreads();

	atomicAdd( nThreadCount, nCount);
}

__global__ void AtomicGlobal( int* nThreadCount)
{
	atomicAdd( nThreadCount, 1);
}

__global__ void ThreadCountDataRace( int* nThreadCount)
{
	(*nThreadCount)++;
}

int main()
{
	const int nBlocks = 10000;		// 
	const int nThreads = 512;		// 

	int host_nThreadCount = 0;
	
	int* dev_nThreadCount;

	//̽ ޸ Ҵ
	cudaMalloc((void**)&dev_nThreadCount, sizeof(int));

	//̽ ޸ ʱȭ
	cudaMemset(dev_nThreadCount, 0, sizeof(int));

	// 
	AtomicGlobal<<<nBlocks,nThreads>>>(dev_nThreadCount);

	//̽ ȣƮ   
	cudaMemcpy(&host_nThreadCount, dev_nThreadCount, sizeof(int), cudaMemcpyDeviceToHost);

	printf("  : %d \n",host_nThreadCount);

	cudaFree(dev_nThreadCount);

	return 0;
}